/**
 * Created by Samuel Gratzl on 26.12.2016.
 */
import * as d3 from 'd3';
import { VALUE_TYPE_CATEGORICAL } from 'phovea_core/src/datatype';
export function defaultColor(value) {
    if (value.type === VALUE_TYPE_CATEGORICAL) {
        return value.categories.map(function (c) { return typeof c === 'string' ? 'gray' : c.color || 'gray'; });
    }
    var nv = value;
    var r = nv.range;
    if (r[0] < 0 && r[1] > 0) {
        //use a symmetric range
        return ['blue', 'white', 'red'];
    }
    return ['white', 'red'];
}
export function defaultDomain(value) {
    if (value.type === VALUE_TYPE_CATEGORICAL) {
        return value.categories.map(function (c) { return typeof c === 'string' ? c : c.name; });
    }
    var nv = value;
    var r = nv.range;
    if (r[0] < 0 && r[1] > 0) {
        //use a symmetric range
        return [Math.min(r[0], -r[1]), 0, Math.max(-r[0], r[1])];
    }
    return r;
}
export function toScale(value) {
    if (value.type === VALUE_TYPE_CATEGORICAL) {
        return d3.scale.ordinal();
    }
    return d3.scale.linear();
}
export function isMissing(v) {
    return (v === null || (typeof v === 'number' && isNaN(v)));
}
//# sourceMappingURL=internal.js.map