/**
 * Created by Samuel Gratzl on 25.01.2016.
 */
import { __extends } from "tslib";
import '../style.scss';
import { scale } from 'd3';
import { mixin } from 'phovea_core/src';
import AList from './internal/AList';
var BarPlot = /** @class */ (function (_super) {
    __extends(BarPlot, _super);
    function BarPlot(data, parent, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, data, parent, mixin({ cssClass: 'phovea-barplot', width: 100, min: NaN, max: NaN }, options)) || this;
        _this.scale = scale.linear();
        _this.build();
        return _this;
    }
    Object.defineProperty(BarPlot.prototype, "maxBarWidth", {
        get: function () {
            var scale = this.options.scale;
            return scale[0] * this.options.width;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarPlot.prototype, "domain", {
        get: function () {
            var r = this.data.valuetype.range;
            return [!isNaN(this.options.min) ? this.options.min : r[0], !isNaN(this.options.max) ? this.options.max : r[1]];
        },
        enumerable: true,
        configurable: true
    });
    BarPlot.prototype.render = function ($enter, $update) {
        var _this = this;
        this.scale.range([0, this.maxBarWidth]);
        var scale = this.options.scale;
        $update.attr('title', function (d) { return String(d); });
        $update.style('width', function (d) { return _this.scale(d) + 'px'; });
    };
    BarPlot.prototype.build = function () {
        this.scale.domain(this.domain).range([0, this.maxBarWidth]);
        return _super.prototype.build.call(this);
    };
    return BarPlot;
}(AList));
export default BarPlot;
export function create(data, parent, options) {
    return new BarPlot(data, parent, options);
}
//# sourceMappingURL=barplot.js.map