/**
 * Created by Samuel Gratzl on 25.01.2016.
 */
import { __extends } from "tslib";
import '../style.scss';
import { format } from 'd3';
import { mixin } from 'phovea_core/src';
import AList from './internal/AList';
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List(data, parent, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, data, parent, mixin({ format: null, rowHeight: 18 }, options)) || this;
        _this.build();
        return _this;
    }
    List.prototype.render = function ($enter, $update) {
        var formatter = this.options.format ? format(this.options.format) : String;
        var factor = this.options.scale[1];
        $update.style('font-size', (factor >= 1 ? null : Math.round(factor * 100) + '%'));
        $update.text(formatter);
    };
    return List;
}(AList));
export { List };
export default List;
export function create(data, parent, options) {
    return new List(data, parent, options);
}
//# sourceMappingURL=list.js.map