/**
 * Created by Samuel Gratzl on 25.01.2016.
 */
import { __extends } from "tslib";
import '../style.scss';
import { scale } from 'd3';
import { mixin } from 'phovea_core/src';
import AList from './internal/AList';
var ProportionalSymbol = /** @class */ (function (_super) {
    __extends(ProportionalSymbol, _super);
    function ProportionalSymbol(data, parent, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, data, parent, mixin({ cssClass: 'phovea-proportional-symbol', width: 20, min: NaN, max: NaN }, options)) || this;
        _this.scale = scale.linear();
        _this.build();
        return _this;
    }
    Object.defineProperty(ProportionalSymbol.prototype, "maxDiameter", {
        get: function () {
            var scale = this.options.scale;
            var w = scale[0] * this.options.width;
            var h = scale[1] * this.options.rowHeight;
            return Math.min(w, h);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProportionalSymbol.prototype, "domain", {
        get: function () {
            var r = this.data.valuetype.range;
            return [!isNaN(this.options.min) ? this.options.min : r[0], !isNaN(this.options.max) ? this.options.max : r[1]];
        },
        enumerable: true,
        configurable: true
    });
    ProportionalSymbol.prototype.render = function ($enter, $update) {
        var _this = this;
        this.scale.range([0, this.maxDiameter]);
        $update.attr('title', function (d) { return String(d); });
        $update.style('width', function (d) { return _this.scale(d) + 'px'; });
        $update.style('height', function (d) { return _this.scale(d) + 'px'; });
    };
    ProportionalSymbol.prototype.build = function () {
        this.scale.domain(this.domain).range([0, this.maxDiameter]);
        return _super.prototype.build.call(this);
    };
    return ProportionalSymbol;
}(AList));
export default ProportionalSymbol;
export function create(data, parent, options) {
    return new ProportionalSymbol(data, parent, options);
}
//# sourceMappingURL=proportionalSymbol.js.map